/* Natural-selection Health Monitor v1.1
*
*          BY: Ramirez
*
*
* Description:
*             This plugin alerts players when their health is below a defined limit.
*  	      The screen flashes red or green depending on team,shakes and a 
*	      "Heartbeat" sound can be heard on a certain rate depending on the class.
*
* ****You can change the health value at wich the alert starts below.****
*
*
* Feel free to post any suggestions/bugs or email me:
*
*					ramirez23@hotmail.com
*
*  This is my first plugin so don't be mean ;)
*  I made a lot of comments so begginers(like me) could use this script as 
*  a reference.
*
*  Special thanks to johnjg75, Freecode, Votorx , Peli , BAILOPAN ...
*  They gave me a big help at understanding the basics of Small...
*  Hope you like this plugin please tell me if you like it or not :D
*  Happy new year!
*/

#include <amxmodx>
#include <ns>
#include <ns2amx>

//***HEALTH VALUE BEFORE NOTIFICATION IS SHOWN***

#define EGG_LH        40	 //ALIEN EGG
#define SKULK_LH      20         //SKULK
#define LERK_LH       30         //LERK
#define FADE_LH       75         //FADE
#define ONOS_LH       250	 //ONOS
#define GORGE_LH      40	 //GORGE
#define RINE_LH	      20         //MARINE    
#define HEAVYRINE_LH  20	 //HEAVY MARINE
#define JPRINE_LH     20	 //JETPACK MARINE

public plugin_precache() {
	precache_sound("monitor/beat.wav")  //Precaching Sound
}

public plugin_init()
{
	register_plugin("Monitor","1.0","Ramirez")
	register_event("Health","dmgtaken","b")   //Checks each time health value is changed
	register_event("ResetHUD","newround","b") //Check on spawning
}

public dmgtaken(id) {

	new CLASSID

	if (ns_get_class(id) == 1 ) {
		CLASSID = SKULK_LH        //Check if player is SKULK
		if (get_user_health(id) < CLASSID ) {
			if (get_user_health(id) > 10 ) {
				remove_task(id)
				set_task(1.0,"shake",id,"",0,"b");
				set_task(1.0,"fadealien",id,"",0,"b");
				set_task(1.0,"lowhealth",id)
			}
			else if (get_user_health(id) < 10 ) {
				remove_task(id)
				set_task(1.0,"shake",id,"",0,"b");
				set_task(1.0,"fadecritical",id,"",0,"b");
				set_task(1.0,"lowhealth2",id)
			}
		
		}
		else if (get_user_health(id) > CLASSID ) {
				remove_task(id)

		}

		return PLUGIN_HANDLED
	}
	else if (ns_get_class(id) == 2 ) {
		CLASSID = GORGE_LH	  //Check if player is GORGE
		if (get_user_health(id) < CLASSID ) {
			if (get_user_health(id) > 10 ) {
				remove_task(id)
				set_task(1.5,"shake",id,"",0,"b");
				set_task(1.5,"fadealien",id,"",0,"b");
				set_task(1.5,"lowhealth",id)
			}
			else if (get_user_health(id) < 10 ) {
				remove_task(id)
				set_task(1.5,"shake",id,"",0,"b");
				set_task(1.5,"fadecritical",id,"",0,"b");
				set_task(1.5,"lowhealth2",id)
			}
		}	
		else if (get_user_health(id) > CLASSID ) {
				remove_task(id)
		}

		return PLUGIN_HANDLED
	}
	else if (ns_get_class(id) == 3 ) {
		CLASSID = LERK_LH         //Check if player is LERK
		if (get_user_health(id) < CLASSID ) {
			if (get_user_health(id) > 10 ) {
				remove_task(id)
				set_task(1.5,"shake",id,"",0,"b");
				set_task(1.5,"fadealien",id,"",0,"b");
				set_task(1.5,"lowhealth",id)
			}
			else if (get_user_health(id) < 10 ) {
				remove_task(id)
				set_task(1.5,"shake",id,"",0,"b");
				set_task(1.5,"fadecritical",id,"",0,"b");
				set_task(1.5,"lowhealth2",id)
			}
		}	
		else if (get_user_health(id) > CLASSID ) {
				remove_task(id)
		}

		return PLUGIN_HANDLED
	}
	else if (ns_get_class(id) == 4 ) {
		CLASSID = FADE_LH         //Check if player is FADE
		if (get_user_health(id) < CLASSID ) {
			if (get_user_health(id) > 10 ) {
				remove_task(id)
				set_task(2.5,"shake",id,"",0,"b");
				set_task(2.5,"fadealien",id,"",0,"b");
				set_task(2.5,"lowhealth",id)
			}
			else if (get_user_health(id) < 10 ) {
				remove_task(id)
				set_task(2.5,"shake",id,"",0,"b");
				set_task(2.5,"fadecritical",id,"",0,"b");
				set_task(2.5,"lowhealth2",id)
			}
		}	
		else if (get_user_health(id) > CLASSID ) {
				remove_task(id)
		}

		return PLUGIN_HANDLED
	}
	else if (ns_get_class(id) == 5 ) {
		CLASSID = ONOS_LH         //Check if player is ONOS
		if (get_user_health(id) < CLASSID ) {
			if (get_user_health(id) > 10 ) {
				remove_task(id)
				set_task(3.0,"shake",id,"",0,"b");
				set_task(3.0,"fadealien",id,"",0,"b");
				set_task(3.0,"lowhealth",id)
			}
			else if (get_user_health(id) < 10 ) {
				remove_task(id)
				set_task(3.0,"shake",id,"",0,"b");
				set_task(3.0,"fadecritical",id,"",0,"b");
				set_task(3.0,"lowhealth2",id)
			}
		}	
		else if (get_user_health(id) > CLASSID ) {
				remove_task(id)
		}

		return PLUGIN_HANDLED
	}
	else if (ns_get_class(id) == 6 ) {
		CLASSID = RINE_LH         //Check if player is MARINE
		if (get_user_health(id) < CLASSID ) {
			if (get_user_health(id) > 10 ) {
				remove_task(id)
				set_task(2.0,"shake",id,"",0,"b");
				set_task(2.0,"fademarine",id,"",0,"b");
				set_task(2.0,"lowhealth",id)
			}
			else if (get_user_health(id) < 10 ) {
				remove_task(id)
				set_task(2.0,"shake",id,"",0,"b");
				set_task(2.0,"fadecritical",id,"",0,"b");
				set_task(2.0,"lowhealth2",id)
			}
		}	
		else if (get_user_health(id) > CLASSID ) {
				remove_task(id)
		}

		return PLUGIN_HANDLED
	}
	else if (ns_get_class(id) == 7 ) {
		CLASSID = JPRINE_LH       //Check if player is JP
		if (get_user_health(id) < CLASSID ) {
			if (get_user_health(id) > 10 ) {
				remove_task(id)
				set_task(2.0,"shake",id,"",0,"b");
				set_task(2.0,"fademarine",id,"",0,"b");
				set_task(2.0,"lowhealth",id)
			}
			else if (get_user_health(id) < 10 ) {
				remove_task(id)
				set_task(2.0,"shake",id,"",0,"b");
				set_task(2.0,"fadecritical",id,"",0,"b");
				set_task(2.0,"lowhealth2",id)
			}
		}	
		else if (get_user_health(id) > CLASSID ) {
				remove_task(id)
		}

		return PLUGIN_HANDLED
	}
	else if (ns_get_class(id) == 8 ) {
		CLASSID = HEAVYRINE_LH    //Check if player is HEAVY
		if (get_user_health(id) < CLASSID ) {
			if (get_user_health(id) > 10 ) {
				remove_task(id)
				set_task(2.0,"shake",id,"",0,"b");
				set_task(2.0,"fademarine",id,"",0,"b");
				set_task(2.0,"lowhealth",id)
			}
			else if (get_user_health(id) < 10 ) {
				remove_task(id)
				set_task(2.0,"shake",id,"",0,"b");
				set_task(2.0,"fadecritical",id,"",0,"b");
				set_task(2.0,"lowhealth2",id)
			}
		}	
		else if (get_user_health(id) > CLASSID ) {
				remove_task(id)
		}

		return PLUGIN_HANDLED
	}
	else if (ns_get_class(id) == 10 ) {
		CLASSID = EGG_LH         //Check if player is EGG
		if (get_user_health(id) < CLASSID ) {
			if (get_user_health(id) > 10 ) {
				remove_task(id)
				set_task(0.5,"shake",id,"",0,"b");
				set_task(0.5,"fadealien",id,"",0,"b");
				set_task(0.5,"lowhealth",id)
			}	
			else if (get_user_health(id) < 10 ) {
				remove_task(id)
				set_task(0.5,"shake",id,"",0,"b");
				set_task(0.5,"fadecritical",id,"",0,"b");
				set_task(0.5,"lowhealth2",id)
			}
		}
		else if (get_user_health(id) > CLASSID ) {
				remove_task(id)
		}

		return PLUGIN_HANDLED
	}

	return PLUGIN_HANDLED
}

public newround(id) {
	remove_task(id)
}

public shake(id) {

	message_begin(MSG_ONE, get_user_msgid("ScreenShake") , {0,0,0}, id)
      	write_short(255<< 10 ) //ammount 
      	write_short(10 << 7 ) //lasts this long 
      	write_short(255<< 14 ) //frequency 
      	message_end() 
	client_cmd(id,"speak sound/monitor/beat.wav")
	return PLUGIN_HANDLED
}

public fademarine(id) {

	message_begin(MSG_ONE,get_user_msgid("ScreenFade"),{0,0,0},id) 
    	write_short( 1000 ) 
    	write_short( 1000 ) 
    	write_short( 1 ) 
    	write_byte( 50 ) // red
    	write_byte( 0 ) // green 
    	write_byte( 0 ) // blue
    	write_byte( 100 ) // alpha
    	message_end()
	return PLUGIN_HANDLED 
}

public fadealien(id) {

	message_begin(MSG_ONE,get_user_msgid("ScreenFade"),{0,0,0},id)
	write_short( 1000 )
	write_short( 1000 )
	write_short( 1 )
	write_byte( 0 ) // red
	write_byte( 50 )  //green
	write_byte( 0 )  //blue
	write_byte( 100 )  //alpha
	message_end()
	return PLUGIN_HANDLED
}

public fadecritical(id) {

	message_begin(MSG_ONE,get_user_msgid("ScreenFade"),{0,0,0},id)
	write_short( 1000 )
	write_short( 1000 )
	write_short( 1 )
	write_byte( 1 ) // red
	write_byte( 1 )  //green
	write_byte( 1 )  //blue
	write_byte( 250 )  //alpha
	message_end()
	return PLUGIN_HANDLED
}

public lowhealth(id) {
	ns_popup(id,"Watch out, you are low in health.")
}

public lowhealth2(id) {
	ns_popup(id,"Watch out, you are almost dead.")
}
